OGRE: Ogre::PixelCountLodStrategy Class Reference - OGRE Documentation

Public Member Functions | Static Public Member Functions | Protected Member Functions | Static Protected Member Functions | Protected Attributes | Static Protected Attributes

# Ogre::PixelCountLodStrategy Class Reference
[LOD]

Level of detail strategy based on pixel count approximation from bounding sphere projection. More...

`#include <OgrePixelCountLodStrategy.h>`

Inheritance diagram for Ogre::PixelCountLodStrategy:
[legend]

List of all members.

## Public Member Functions
| PixelCountLodStrategy ()
| Default constructor.
virtual Real | getBaseValue () const
virtual Real | transformBias (Real factor) const
virtual ushort | getIndex (Real value, const Mesh::MeshLodUsageList &meshLodUsageList) const
virtual ushort | getIndex (Real value, const Material::LodValueList &materialLodValueList) const
virtual void | sort (Mesh::MeshLodUsageList &meshLodUsageList) const
virtual bool | isSorted (const Mesh::LodValueList &values) const
virtual Real | getBaseValue () const =0
| Get the value of the first (highest) level of detail.
virtual Real | transformBias (Real factor) const =0
| Transform lod bias so it only needs to be multiplied by the lod value.
virtual Real | transformUserValue (Real userValue) const
| Transforum user supplied value to internal value.
Real | getValue (const MovableObject *movableObject, const Camera *camera) const
| Compute the lod value for a given movable object relative to a given camera.
virtual ushort | getIndex (Real value, const Mesh::MeshLodUsageList &meshLodUsageList) const =0
| Get the index of the lod usage which applies to a given value.
virtual ushort | getIndex (Real value, const Material::LodValueList &materialLodValueList) const =0
| Get the index of the lod usage which applies to a given value.
virtual void | sort (Mesh::MeshLodUsageList &meshLodUsageList) const =0
| Sort mesh lod usage list from greatest to least detail.
virtual bool | isSorted (const Mesh::LodValueList &values) const =0
| Determine if the lod values are sorted from greatest detail to least detail.
void | assertSorted (const Mesh::LodValueList &values) const
| Assert that the lod values are sorted from greatest detail to least detail.
const String & | getName () const
| Get the name of this strategy.
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info
void * | operator new (size_t sz)
void * | operator new (size_t sz, void *ptr)
| placement operator new
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info
void * | operator new[] (size_t sz)
void | operator delete (void *ptr)
void | operator delete (void *ptr, void *)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
## Static Public Member Functions
static PixelCountLodStrategy & | getSingleton (void)
| Override standard Singleton retrieval.
static PixelCountLodStrategy * | getSingletonPtr (void)
| Override standard Singleton retrieval.
## Protected Member Functions
virtual Real | getValueImpl (const MovableObject *movableObject, const Camera *camera) const
virtual Real | getValueImpl (const MovableObject *movableObject, const Camera *camera) const =0
| Compute the lod value for a given movable object relative to a given camera.
## Static Protected Member Functions
static bool | isSortedAscending (const Mesh::LodValueList &values)
| Implementation of isSorted suitable for ascending values.
static bool | isSortedDescending (const Mesh::LodValueList &values)
| Implementation of isSorted suitable for descending values.
static void | sortAscending (Mesh::MeshLodUsageList &meshLodUsageList)
| Implementation of sort suitable for ascending values.
static void | sortDescending (Mesh::MeshLodUsageList &meshLodUsageList)
| Implementation of sort suitable for descending values.
static ushort | getIndexAscending (Real value, const Mesh::MeshLodUsageList &meshLodUsageList)
| Implementation of getIndex suitable for ascending values.
static ushort | getIndexAscending (Real value, const Material::LodValueList &materialLodValueList)
| Implementation of getIndex suitable for ascending values.
static ushort | getIndexDescending (Real value, const Mesh::MeshLodUsageList &meshLodUsageList)
| Implementation of getIndex suitable for descending values.
static ushort | getIndexDescending (Real value, const Material::LodValueList &materialLodValueList)
| Implementation of getIndex suitable for descending values.
## Protected Attributes
String | mName
| Name of this strategy.
## Static Protected Attributes
static PixelCountLodStrategy * | ms_Singleton

## Detailed Description

Level of detail strategy based on pixel count approximation from bounding sphere projection.

Definition at line 46 of file OgrePixelCountLodStrategy.h.

## Constructor & Destructor Documentation

Ogre::PixelCountLodStrategy::PixelCountLodStrategy | ( |  | ) |

Default constructor.

## Member Function Documentation

void Ogre::LodStrategy::assertSorted | ( | const Mesh::LodValueList & | values | ) | const`[inherited]`

Assert that the lod values are sorted from greatest detail to least detail.

virtual Real Ogre::PixelCountLodStrategy::getBaseValue | ( |  | ) | const`[virtual]`

Get the value of the first (highest) level of detail.

virtual Real Ogre::LodStrategy::getBaseValue | ( |  | ) | const`[pure virtual, inherited]`

Get the value of the first (highest) level of detail.

virtual ushort Ogre::LodStrategy::getIndex | ( | Real | value,
|  | const Material::LodValueList & | materialLodValueList |
| ) |  |  | const`[pure virtual, inherited]`

Get the index of the lod usage which applies to a given value.

virtual ushort Ogre::PixelCountLodStrategy::getIndex | ( | Real | value,
|  | const Mesh::MeshLodUsageList & | meshLodUsageList |
| ) |  |  | const`[virtual]`

Get the index of the lod usage which applies to a given value.

virtual ushort Ogre::PixelCountLodStrategy::getIndex | ( | Real | value,
|  | const Material::LodValueList & | materialLodValueList |
| ) |  |  | const`[virtual]`

Get the index of the lod usage which applies to a given value.

virtual ushort Ogre::LodStrategy::getIndex | ( | Real | value,
|  | const Mesh::MeshLodUsageList & | meshLodUsageList |
| ) |  |  | const`[pure virtual, inherited]`

Get the index of the lod usage which applies to a given value.

static ushort Ogre::LodStrategy::getIndexAscending | ( | Real | value,
|  | const Mesh::MeshLodUsageList & | meshLodUsageList |
| ) |  |  | `[static, protected, inherited]`

Implementation of getIndex suitable for ascending values.

static ushort Ogre::LodStrategy::getIndexAscending | ( | Real | value,
|  | const Material::LodValueList & | materialLodValueList |
| ) |  |  | `[static, protected, inherited]`

Implementation of getIndex suitable for ascending values.

static ushort Ogre::LodStrategy::getIndexDescending | ( | Real | value,
|  | const Mesh::MeshLodUsageList & | meshLodUsageList |
| ) |  |  | `[static, protected, inherited]`

Implementation of getIndex suitable for descending values.

static ushort Ogre::LodStrategy::getIndexDescending | ( | Real | value,
|  | const Material::LodValueList & | materialLodValueList |
| ) |  |  | `[static, protected, inherited]`

Implementation of getIndex suitable for descending values.

const String& Ogre::LodStrategy::getName | ( | void |  | ) | const`[inherited]`

Get the name of this strategy.

Definition at line 103 of file OgreLodStrategy.h.

static PixelCountLodStrategy& Ogre::PixelCountLodStrategy::getSingleton | ( | void |  | ) | `[static]`

Override standard Singleton retrieval.

Remarks:
  Why do we do this? Well, it's because the Singleton implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the Singleton template to work, but we actually only want it compiled into the implementation of the class based on the Singleton, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll.

  This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors.

Reimplemented from Ogre::Singleton< PixelCountLodStrategy >.

static PixelCountLodStrategy* Ogre::PixelCountLodStrategy::getSingletonPtr | ( | void |  | ) | `[static]`

Override standard Singleton retrieval.

Remarks:
  Why do we do this? Well, it's because the Singleton implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the Singleton template to work, but we actually only want it compiled into the implementation of the class based on the Singleton, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll.

  This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors.

Reimplemented from Ogre::Singleton< PixelCountLodStrategy >.

Real Ogre::LodStrategy::getValue | ( | const MovableObject * | movableObject,
|  | const Camera * | camera |
| ) |  |  | const`[inherited]`

Compute the lod value for a given movable object relative to a given camera.

virtual Real Ogre::PixelCountLodStrategy::getValueImpl | ( | const MovableObject * | movableObject,
|  | const Camera * | camera |
| ) |  |  | const`[protected, virtual]`

Compute the lod value for a given movable object relative to a given camera.

virtual Real Ogre::LodStrategy::getValueImpl | ( | const MovableObject * | movableObject,
|  | const Camera * | camera |
| ) |  |  | const`[protected, pure virtual, inherited]`

Compute the lod value for a given movable object relative to a given camera.

virtual bool Ogre::LodStrategy::isSorted | ( | const Mesh::LodValueList & | values | ) | const`[pure virtual, inherited]`

Determine if the lod values are sorted from greatest detail to least detail.

virtual bool Ogre::PixelCountLodStrategy::isSorted | ( | const Mesh::LodValueList & | values | ) | const`[virtual]`

Determine if the lod values are sorted from greatest detail to least detail.

static bool Ogre::LodStrategy::isSortedAscending | ( | const Mesh::LodValueList & | values | ) | `[static, protected, inherited]`

Implementation of isSorted suitable for ascending values.

static bool Ogre::LodStrategy::isSortedDescending | ( | const Mesh::LodValueList & | values | ) | `[static, protected, inherited]`

Implementation of isSorted suitable for descending values.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) | `[inherited]`

Definition at line 95 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |  |
| ) |  |  | `[inherited]`

Definition at line 101 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 107 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) | `[inherited]`

Definition at line 112 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 118 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

operator new, with debug line info

Definition at line 67 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr |
| ) |  |  | `[inherited]`

placement operator new

Definition at line 78 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) | `[inherited]`

Definition at line 72 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) | `[inherited]`

Definition at line 90 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

array operator new, with debug line info

Definition at line 85 of file OgreMemoryAllocatedObject.h.

virtual void Ogre::LodStrategy::sort | ( | Mesh::MeshLodUsageList & | meshLodUsageList | ) | const`[pure virtual, inherited]`

Sort mesh lod usage list from greatest to least detail.

virtual void Ogre::PixelCountLodStrategy::sort | ( | Mesh::MeshLodUsageList & | meshLodUsageList | ) | const`[virtual]`

Sort mesh lod usage list from greatest to least detail.

static void Ogre::LodStrategy::sortAscending | ( | Mesh::MeshLodUsageList & | meshLodUsageList | ) | `[static, protected, inherited]`

Implementation of sort suitable for ascending values.

static void Ogre::LodStrategy::sortDescending | ( | Mesh::MeshLodUsageList & | meshLodUsageList | ) | `[static, protected, inherited]`

Implementation of sort suitable for descending values.

virtual Real Ogre::LodStrategy::transformBias | ( | Real | factor | ) | const`[pure virtual, inherited]`

Transform lod bias so it only needs to be multiplied by the lod value.

virtual Real Ogre::PixelCountLodStrategy::transformBias | ( | Real | factor | ) | const`[virtual]`

Transform lod bias so it only needs to be multiplied by the lod value.

virtual Real Ogre::LodStrategy::transformUserValue | ( | Real | userValue | ) | const`[virtual, inherited]`

Transforum user supplied value to internal value.

Remarks:
  By default, performs no transformation.
  Do not throw exceptions for invalid values here, as the lod strategy may be changed such that the values become valid.

## Member Data Documentation

String Ogre::LodStrategy::mName`[protected, inherited]`

Name of this strategy.

Definition at line 57 of file OgreLodStrategy.h.

PixelCountLodStrategy * Ogre::Singleton< PixelCountLodStrategy >::ms_Singleton`[static, protected, inherited]`

Definition at line 75 of file OgreSingleton.h.

The documentation for this class was generated from the following file:

- OgrePixelCountLodStrategy.h

Copyright © 2008 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 Unported License.
Last modified Wed Nov 3 2010 19:24:58